#ifndef LEVEL_H
#define LEVEL_H

#include <string.h>

class Player;  // Forward declaration
#include "list.h"

struct range { 
    void setRange(char *r);
    long int random(); // returns a random integer in the set {low..high}
    long int high; 
    long int low;
};

class Level {
public:
    Level(); // Constructor
    Monster *randomMonster();
    void setStrength(range &s);
    void setGold(range &g);
    void setExp(range &e);
    void setHP(range &h);

    bool loadLevel(char *filename);

    range getStrength() { return strength; };
    range getGold() { return gold; };
    range getExp() { return exp; };
    range getHP() { return hp; };
    List<Monster> monsters;
    Monster master;

private:
    range strength;    
    range gold;
    range exp;
    range hp;
};


#endif
